{-
	Copyright (C) 2011 Dr. Alistair Ward

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
-}
{- |
 [@AUTHOR@]	Dr. Alistair Ward

 [@DESCRIPTION@]	Measures the CPU-time required by "Math.Primes.primes".
-}

module Factory.Test.Performance.Primes(
-- * Functions
	primesPerformance
) where

import qualified	Control.DeepSeq
import qualified	Data.Array.IArray
import qualified	Factory.Math.Primes	as Math.Primes
import qualified	ToolShed.TimePure	as TimePure

-- | Measures the CPU-time required by 'Math.Primes.primes', to find the specified prime.
primesPerformance :: (Math.Primes.Algorithmic algorithm, Control.DeepSeq.NFData i, Data.Array.IArray.Ix i, Integral i) => algorithm -> Int -> IO (Double, i)
primesPerformance algorithm	= TimePure.getCPUSeconds . (Math.Primes.primes algorithm !!)
